CREATE TABLE CENS 
(
  CODCEN VARCHAR2(20) NOT NULL 
, TIPCEN VARCHAR2(3) NOT NULL 
, CEN_CODCEN VARCHAR2(20) 
, EST_CODEST VARCHAR2(2) 
, REG_CODREG VARCHAR2(9) 
, LOC_CODLOC VARCHAR2(9) 
, CONSTRAINT PK_CENS PRIMARY KEY 
  (
    CODCEN 
  )
  ENABLE 
);

ALTER TABLE CENS
ADD CONSTRAINT FK_CENS_CENS FOREIGN KEY
(
  CEN_CODCEN 
)
REFERENCES CENS
(
  CODCEN 
)
ENABLE;

ALTER TABLE CENS
ADD CONSTRAINT FK_CENS_ESTAT FOREIGN KEY
(
  EST_CODEST 
)
REFERENCES ESTAT
(
  CODEST 
)
ENABLE;

ALTER TABLE CENS
ADD CONSTRAINT FK_CENS_LOCALITAT FOREIGN KEY
(
  EST_CODEST 
, REG_CODREG 
, LOC_CODLOC 
)
REFERENCES LOCALITAT
(
  EST_CODEST 
, REG_CODREG 
, CODLOC 
)
ENABLE;

ALTER TABLE CENS
ADD CONSTRAINT FK_CENS_REGIO FOREIGN KEY
(
  EST_CODEST 
, REG_CODREG 
)
REFERENCES REGIO
(
  EST_CODEST 
, CODREG 
)
ENABLE;

ALTER TABLE CENS
ADD CONSTRAINT CK_TIPCEN CHECK 
(TIPCEN IN ('GLB', 'EST', 'REG', 'LOC'))
ENABLE;

COMMENT ON COLUMN CENS.CODCEN IS 'Cens (Codi)';

COMMENT ON COLUMN CENS.TIPCEN IS 'Cens (Tipus de cens: "GLB" - global, "EST" - estatal, "REG" - regional o "LOC" - local)';

COMMENT ON COLUMN CENS.CEN_CODCEN IS 'Cens (Codi cens superior)';

COMMENT ON COLUMN CENS.EST_CODEST IS 'Esat (Codi)';

COMMENT ON COLUMN CENS.REG_CODREG IS 'Regi (Codi)';

COMMENT ON COLUMN CENS.LOC_CODLOC IS 'Localitat (Codi)';

CREATE INDEX IF_CENS_CENS ON CENS (CEN_CODCEN);

CREATE INDEX IF_CENS_LOCALITAT ON CENS (EST_CODEST, REG_CODREG, LOC_CODLOC);

exit
/