CREATE TABLE CIUTADA 
(
  CODCTD VARCHAR2(9) NOT NULL 
, DATNAC DATE NOT NULL 
, EST_CODEST VARCHAR2(2) NOT NULL 
, REG_CODREG VARCHAR2(9) NOT NULL 
, LOC_CODLOC VARCHAR2(9) NOT NULL 
, CONSTRAINT PK_CIUTADA PRIMARY KEY 
  (
    CODCTD 
  )
  ENABLE 
);

ALTER TABLE CIUTADA
ADD CONSTRAINT FK_CIUTADA_LOCALITAT FOREIGN KEY
(
  EST_CODEST 
, REG_CODREG 
, LOC_CODLOC 
)
REFERENCES LOCALITAT
(
  EST_CODEST 
, REG_CODREG 
, CODLOC 
)
ENABLE;

COMMENT ON COLUMN CIUTADA.CODCTD IS 'Ciutad (Codi)';

COMMENT ON COLUMN CIUTADA.DATNAC IS 'Ciutad (Data de naixament)';

COMMENT ON COLUMN CIUTADA.EST_CODEST IS 'Estat (Codi)';

COMMENT ON COLUMN CIUTADA.REG_CODREG IS 'Regi (Codi)';

COMMENT ON COLUMN CIUTADA.LOC_CODLOC IS 'Localitat (Codi)';

CREATE INDEX IF_CIUTADA_LOCALITAT ON CIUTADA (EST_CODEST, REG_CODREG, LOC_CODLOC);

exit
/