CREATE TABLE LOCALITAT 
(
  EST_CODEST VARCHAR2(2) NOT NULL 
, REG_CODREG VARCHAR2(9) NOT NULL 
, CODLOC VARCHAR2(9) NOT NULL 
, NOMLOC VARCHAR2(100) NOT NULL 
, CONSTRAINT PK_LOCALITAT PRIMARY KEY 
  (
    EST_CODEST 
  , REG_CODREG 
  , CODLOC 
  )
  ENABLE 
);

CREATE TABLE REGIO 
(
  EST_CODEST VARCHAR2(2) NOT NULL 
, CODREG VARCHAR2(9) NOT NULL 
, NOMREG VARCHAR2(100) NOT NULL 
, CONSTRAINT PK_REGIO PRIMARY KEY 
  (
    EST_CODEST 
  , CODREG 
  )
  ENABLE 
);

CREATE TABLE ESTAT 
(
  CODEST VARCHAR2(2) NOT NULL 
, NOMEST VARCHAR2(100) NOT NULL 
, CONSTRAINT PK_EST PRIMARY KEY 
  (
    CODEST 
  )
  ENABLE 
);

ALTER TABLE LOCALITAT
ADD CONSTRAINT FK_LOCALITAT_REGIO FOREIGN KEY
(
  EST_CODEST 
, REG_CODREG 
)
REFERENCES REGIO
(
  EST_CODEST 
, CODREG 
)
ENABLE;

ALTER TABLE REGIO
ADD CONSTRAINT FK_REGIO_ESTAT FOREIGN KEY
(
  EST_CODEST 
)
REFERENCES ESTAT
(
  CODEST 
)
ENABLE;

COMMENT ON COLUMN LOCALITAT.EST_CODEST IS 'Estat (Codi)';

COMMENT ON COLUMN LOCALITAT.REG_CODREG IS 'Regi (Codi)';

COMMENT ON COLUMN LOCALITAT.CODLOC IS 'Localitat (Codi)';

COMMENT ON COLUMN LOCALITAT.NOMLOC IS 'Localitat (Nom)';

COMMENT ON COLUMN REGIO.EST_CODEST IS 'Estat (Codi)';

COMMENT ON COLUMN REGIO.CODREG IS 'Regi (Codi)';

COMMENT ON COLUMN REGIO.NOMREG IS 'Regi (Nom)';

COMMENT ON COLUMN ESTAT.CODEST IS 'Estat (codi)';

COMMENT ON COLUMN ESTAT.NOMEST IS 'Estat (Nom)';

exit
/
