CREATE TABLE DETALL_LOG 
(
  LOG_IDELOG NUMBER(9) NOT NULL 
, NUMDLG NUMBER(9) NOT NULL 
, INFDLG VARCHAR2(2000) NOT NULL 
, CONSTRAINT RP_DLG PRIMARY KEY 
  (
    LOG_IDELOG 
  , NUMDLG 
  )
  ENABLE 
);

CREATE TABLE LOG_INFO 
(
  IDELOG NUMBER(9) NOT NULL 
, INFPRC VARCHAR2(40) NOT NULL 
, INFOBS VARCHAR2(256) 
, FECINIPRC DATE NOT NULL 
, FECFINPRC DATE 
, LSTESTPRC VARCHAR2(3) NOT NULL 
, CONSTRAINT RP_LOG PRIMARY KEY 
  (
    IDELOG 
  )
  ENABLE 
);

ALTER TABLE DETALL_LOG
ADD CONSTRAINT RF_DLG_LOG FOREIGN KEY
(
  LOG_IDELOG 
)
REFERENCES LOG_INFO
(
  IDELOG 
)
ENABLE;

ALTER TABLE LOG_INFO
ADD CONSTRAINT RC_LOG_LSTESTPRC CHECK 
(LSTESTPRC IN ('INI', 'FIN', 'ERR'))
ENABLE;

COMMENT ON COLUMN DETALL_LOG.LOG_IDELOG IS 'Informaci Log (Identificador)
';

COMMENT ON COLUMN DETALL_LOG.NUMDLG IS 'Detalle Log (Nmero detall)';

COMMENT ON COLUMN DETALL_LOG.INFDLG IS 'Detalle Log (Text detall)';

COMMENT ON COLUMN LOG_INFO.IDELOG IS 'Informaci Log (Identificador)';

COMMENT ON COLUMN LOG_INFO.INFPRC IS 'Informaci Log (Procs)';

COMMENT ON COLUMN LOG_INFO.INFOBS IS 'Informaci Log (Observacions)';

COMMENT ON COLUMN LOG_INFO.FECINIPRC IS 'Informaci Log (Inici procs)';

COMMENT ON COLUMN LOG_INFO.FECFINPRC IS 'Informaci Log (Fi procs)';

COMMENT ON COLUMN LOG_INFO.LSTESTPRC IS 'Inforormaci Porcs (Estat procs)';

CREATE SEQUENCE SEQ_LOG_INFO INCREMENT BY 1 START WITH 1;

exit
/