CREATE TABLE CENS_VOTACIO 
(
  VOT_CODVOT VARCHAR2(10) NOT NULL 
, CEN_CODCEN VARCHAR2(20) NOT NULL 
, CONSTRAINT PK_CENS_VOTACIO PRIMARY KEY 
  (
    VOT_CODVOT 
  , CEN_CODCEN 
  )
  ENABLE 
);

CREATE TABLE VOTACIO 
(
  CODVOT VARCHAR2(10) NOT NULL 
, INFTITVOT VARCHAR2(140) NOT NULL 
, DESVOT CLOB NOT NULL 
, ESTVOT VARCHAR2(3) NOT NULL 
, DATPUBVOT DATE NOT NULL 
, DATINIVOT DATE NOT NULL 
, DATFINVOT DATE NOT NULL 
, INFNOMPRS VARCHAR2(140) NOT NULL 
, INFWEB VARCHAR2(256) 
, NUMTOTCTD NUMBER(9) DEFAULT 0 
, NUMTOTVOT NUMBER(9) DEFAULT 0 
, PRCPRT NUMBER(5, 2) DEFAULT 0 
, NUMDIFOPV NUMBER(5, 2) DEFAULT 0 
, CONSTRAINT PK_VOTACIO PRIMARY KEY 
  (
    CODVOT 
  )
  ENABLE 
);

CREATE TABLE OPCIO_VOTACIO 
(
  VOT_CODVOT VARCHAR2(10) NOT NULL 
, CODOPV VARCHAR2(9) NOT NULL 
, INFTITOPV VARCHAR2(140) NOT NULL 
, DESOPV CLOB 
, NUMVOT NUMBER(9) DEFAULT 0 NOT NULL 
, PRCVOT NUMBER(5, 2) 
, FLGGNY VARCHAR2(1) 
, CONSTRAINT PK_OPCIO_VOTACIO PRIMARY KEY 
  (
    VOT_CODVOT 
  , CODOPV 
  )
  ENABLE 
);

CREATE TABLE VOT_EMES 
(
  VOT_CODVOT VARCHAR2(10) NOT NULL 
, CTD_CODCTD VARCHAR2(9) NOT NULL 
, CONSTRAINT PK_VOT_EMES PRIMARY KEY 
  (
    VOT_CODVOT 
  , CTD_CODCTD 
  )
  ENABLE 
);

ALTER TABLE CENS_VOTACIO
ADD CONSTRAINT FK_CENS_VOTACIO_CENS FOREIGN KEY
(
  CEN_CODCEN 
)
REFERENCES CENS
(
  CODCEN 
)
ENABLE;

ALTER TABLE CENS_VOTACIO
ADD CONSTRAINT FK_CENS_VOTACIO_VOTACIO FOREIGN KEY
(
  VOT_CODVOT 
)
REFERENCES VOTACIO
(
  CODVOT 
)
ENABLE;

ALTER TABLE OPCIO_VOTACIO
ADD CONSTRAINT OPCIO_VOTACIO_VOTACIO_FK FOREIGN KEY
(
  VOT_CODVOT 
)
REFERENCES VOTACIO
(
  CODVOT 
)
ENABLE;

ALTER TABLE VOT_EMES
ADD CONSTRAINT FK_VOT_EMES_CIUTADA_CIUTADA FOREIGN KEY
(
  CTD_CODCTD 
)
REFERENCES CIUTADA
(
  CODCTD 
)
ENABLE;

ALTER TABLE VOT_EMES
ADD CONSTRAINT FK_VOT_EMES_VOTACIO_VOTACIO FOREIGN KEY
(
  VOT_CODVOT 
)
REFERENCES VOTACIO
(
  CODVOT 
)
ENABLE;

ALTER TABLE VOTACIO
ADD CONSTRAINT CK_VOTACIO_ESTVOT CHECK 
(ESTVOT IN ('EDI', 'PDT', 'INI', 'FIN'))
ENABLE;

ALTER TABLE OPCIO_VOTACIO
ADD CONSTRAINT RC_OPV_FLGGNY CHECK 
(FLGGNY IN ('S', 'N'))
ENABLE;

COMMENT ON COLUMN VOTACIO.CODVOT IS 'Votaci (Codi)';

COMMENT ON COLUMN VOTACIO.INFTITVOT IS 'Votaci (Ttol)';

COMMENT ON COLUMN VOTACIO.DESVOT IS 'Votaci (Descripci)';

COMMENT ON COLUMN VOTACIO.ESTVOT IS 'Votaci  (Estat: "EDI" - en edici, "PDT" - pendent d''obertura, "INI" - oberta i "FIN" - finalitzada )';

COMMENT ON COLUMN VOTACIO.DATPUBVOT IS 'Votaci (Data de publicaci)';

COMMENT ON COLUMN VOTACIO.DATINIVOT IS 'Votaci (Data inici votaci)';

COMMENT ON COLUMN VOTACIO.DATFINVOT IS 'Votaci (Data fi votaci)';

COMMENT ON COLUMN VOTACIO.INFNOMPRS IS 'Votaci (Nom del president de la mesa virtual)';

COMMENT ON COLUMN VOTACIO.INFWEB IS 'Votaci (Adrea web amb explicacions detallades)';

COMMENT ON COLUMN VOTACIO.NUMTOTCTD IS 'Votaci (Nmero total de ciutadans amb dret a vot en el moment de tancar la votaci)';

COMMENT ON COLUMN VOTACIO.NUMTOTVOT IS 'Votaci (Nmero total de vots emesos)';

COMMENT ON COLUMN VOTACIO.PRCPRT IS 'Votaci (Percentatge de participaci)';

COMMENT ON COLUMN VOTACIO.NUMDIFOPV IS 'Votaci (Diferncia entre la opci ms votada i la que menys)';

COMMENT ON COLUMN OPCIO_VOTACIO.VOT_CODVOT IS 'Votaci (Codi)';

COMMENT ON COLUMN OPCIO_VOTACIO.CODOPV IS 'Opci votaci (Codi)';

COMMENT ON COLUMN OPCIO_VOTACIO.INFTITOPV IS 'Opci votaci (Ttol)';

COMMENT ON COLUMN OPCIO_VOTACIO.DESOPV IS 'Opci votaci (Informaci sobre l''opci)';

COMMENT ON COLUMN OPCIO_VOTACIO.NUMVOT IS 'Opci votaci (Nmero de vots rebuts)';

COMMENT ON COLUMN OPCIO_VOTACIO.PRCVOT IS 'Opci votaci (Percentatge de vots rebuts sobre el total)';

COMMENT ON COLUMN OPCIO_VOTACIO.FLGGNY IS 'Opci votaci (s la opci guanyadora?)';

CREATE INDEX IF_CENS_VOTACIO_CENS ON CENS_VOTACIO (CEN_CODCEN);

CREATE INDEX IF_VOT_EMES_CIUTADA ON VOT_EMES (CTD_CODCTD);

exit
/
