create or replace package CONSULTES_PKG is

  -- Donat un pas, obt el llistat de les votacions que s'hi han produt.
  --
  -- Taula d'errors del procs
  --
  -- Codi derror  Descripci
  -- ------------  -----------------------------------
  -- 100           Sha dinformar  el codi de l'estat
  -- 101           L'estat no existeix
  -- 900           Error inesperat
  --
  -- %param P_CODESt      Codi d'estat
  -- %param P_RSP    OUT  Codi de resposta. Si el procs dalta acabat amb xit, retorn el
  --                      valor OK, sin retorna un codi derror  seguit de la descripci,
  --                      seguint el format CODI-DESCRIPCIӔ
  -- %param P_LLISTAT OUT Cursor referenciat que cont les dades del llistat.
  PROCEDURE VOTACIONS_PER_ESTAT (P_CODEST        ESTAT.CODEST%TYPE,
                                 P_RSP       OUT VARCHAR2,
                                 P_LLISTAT   OUT SYS_REFCURSOR);
                                 

  -- Donat un pas, obt el llistat de les votacions que s'hi han produt.
  --
  -- Taula d'errors del procs
  --
  -- Codi derror  Descripci
  -- ------------  -----------------------------------
  -- 900           Error inesperat
  --
  -- %param P_RSP    OUT  Codi de resposta. Si el procs dalta acabat amb xit, retorn el
  --                      valor OK, sin retorna un codi derror  seguit de la descripci,
  --                      seguint el format CODI-DESCRIPCIӔ
  -- %param P_LLISTAT OUT Cursor referenciat que cont les dades del llistat.
  PROCEDURE VOTACIONS_MES_DIFERENCIA (P_RSP       OUT VARCHAR2,
                                      P_LLISTAT   OUT SYS_REFCURSOR);

  -- Obt el llistat de les 10 votacions que han tingut menys diferencia entre la
  -- opci ms votada i la menys votada
  --
  -- Taula d'errors del procs
  --
  -- Codi derror  Descripci
  -- ------------  -----------------------------------
  -- 900           Error inesperat
  --
  -- %param P_RSP    OUT  Codi de resposta. Si el procs dalta acabat amb xit, retorn el
  --                      valor OK, sin retorna un codi derror  seguit de la descripci,
  --                      seguint el format CODI-DESCRIPCIӔ
  -- %param P_LLISTAT OUT Cursor referenciat que cont les dades del llistat.
  PROCEDURE VOTACIONS_MENYS_DIFERENCIA (P_RSP       OUT VARCHAR2,
                                        P_LLISTAT   OUT SYS_REFCURSOR);


  -- Donat el codi d'un ciutad, obt els censos als quals pertany.
  --
  -- Taula d'errors del procs
  --
  -- Codi derror  Descripci
  -- ------------  -----------------------------------
  -- 100           Sha dinformar  el codi del ciutad
  -- 101           El ciutad no existeix
  -- 900           Error inesperat
  --
  -- %param P_CODESt      Codi d'estat
  -- %param P_RSP    OUT  Codi de resposta. Si el procs dalta acabat amb xit, retorn el
  --                      valor OK, sin retorna un codi derror  seguit de la descripci,
  --                      seguint el format CODI-DESCRIPCIӔ
  -- %param P_LLISTAT OUT Cursor referenciat que cont les dades del llistat.
  PROCEDURE CENSOS_CIUTADA (P_CODCTD        CIUTADA.CODCTD%TYPE,
                            P_RSP       OUT VARCHAR2,
                            P_LLISTAT   OUT SYS_REFCURSOR);

  -- Donat el codi d'un ciutad, obt les votacions en que ha participat i les que no
  --
  -- Taula d'errors del procs
  --
  -- Codi derror  Descripci
  -- ------------  -----------------------------------
  -- 100           Sha dinformar  el codi del ciutad
  -- 101           El ciutad no existeix
  -- 900           Error inesperat
  --
  -- %param P_CODESt      Codi d'estat
  -- %param P_RSP    OUT  Codi de resposta. Si el procs dalta acabat amb xit, retorn el
  --                      valor OK, sin retorna un codi derror  seguit de la descripci,
  --                      seguint el format CODI-DESCRIPCIӔ
  -- %param P_LLISTAT OUT Cursor referenciat que cont les dades del llistat.
  PROCEDURE VOTACIONS_CIUTADA (P_CODCTD        CIUTADA.CODCTD%TYPE,
                               P_RSP       OUT VARCHAR2,
                               P_LLISTAT   OUT SYS_REFCURSOR);
end;
/

exit
/

