create or replace package LOG_PKG is

  -- Estats del procs
  cESTAT_INICIALITZAT  constant varchar2(3) := 'INI';  -- Inicialitzat
  cESTAT_FINALITZAT    constant varchar2(3) := 'FIN';  -- Finalitzat
  cESTAT_AMB_ERRORS    constant varchar2(3) := 'ERR';  -- Executat amb errors

  -- Inicialitza un log de procs.
  -- NOTA: usa una transacci autnoma i realitzar COMMIT.
  --
  -- %param P_INFPRC  Nom del proces logat
  -- %param P_INFOBS  Observacions
  --
  -- %return Identificador del log iniciat
  FUNCTION INICIAR_LOG (P_INFPRC    LOG_INFO.INFPRC%TYPE,
                        P_INFOBS    LOG_INFO.INFOBS%TYPE
                       ) RETURN LOG_INFO.IDELOG%TYPE;

  -- Registra una lnia de detalle del log d'un procs
  -- NOTA: usa una transacci autnoma i realitzar COMMIT.
  --
  -- %param P_IDELOG  Id. del log on es vol registrar el detall
  -- %param P_INFDLG  Text del detall de log
  PROCEDURE REGISTRAR_DETALL_LOG (P_IDELOG    DETALL_LOG.LOG_IDELOG%TYPE,
                                  P_INFDLG    DETALL_LOG.INFDLG%TYPE);

  -- Finalitza un log de procs. Es guarda com a data de fi la
  -- data de sisteam
  -- NOTA: usa una transacci autnoma i realitzar COMMIT.
  --
  -- %param P_IDELOG     Id. de log a finalitzar
  -- %param P_LSTESTPRC  Esta final del procs
  --                         {*} FIN  Finalitzat correctament
  --                         {*} ERR  Finalitzat amb errors
  PROCEDURE FINALITZAR_LOG (P_IDELOG       LOG_INFO.IDELOG%TYPE,
                            P_LSTESTPRC    LOG_INFO.LSTESTPRC%TYPE);

  -- Mostra la informaci de log a travs de l'"OUTPUT"
  --
  -- %param P_IDELOG  Id del log a mostrar
  PROCEDURE MOSTRAR_LOG (P_IDELOG    LOG_INFO.IDELOG%TYPE);

end;
/

exit
/

