set termout off
set feedback off
set trims on
set serveroutput on size unlimited
spool .\resultats\consultes.txt

declare
  cLlistat    sys_refcursor;
  vRsp        varchar2(4000);
  vINFTITVOT  varchar2(4000);
  vDATINIVOT  date;
  vDATFINVOT  date;
  vESTVOT     varchar2(4000);
  vNUMCTDVOT  varchar2(4000);
  vPRCPRT     varchar2(4000);
  vCODOPVGUA  varchar2(4000);
  vPRCOPVGUA  varchar2(4000);
  vCOPOPVMAX varchar2(4000);
  vPRCVOTMAX number;
  vCOPOPVMIN varchar2(4000);
  vPRCVOTMIN number;
  vDIFPRCVOT number;
  vNum       number;
  vCODCEN    varchar2(4000);
  vVar       varchar2(2000);
begin
  
  dbms_output.put_line('-- ====================================================================');
  dbms_output.put_line('-- Joc de proves per als procediments del subsistema de consultes');
  dbms_output.put_line('--');
  dbms_output.put_line('-- ====================================================================');
  dbms_output.put_line('--');

  dbms_output.put_line('Votacions d''un estat');  
  CONSULTES_PKG.VOTACIONS_PER_ESTAT ('ES', vRsp, cLlistat);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line (rpad ('TTOL', 20, ' ') || ' ' ||
                          rpad ('Inici', 10, ' ')  || ' ' ||
                          rpad ('Fi', 10, ' ')  || ' ' ||
                          rpad ('Estat', 15, ' ')     || ' ' ||
                          rpad ('Ctd.', 6, ' ') || ' ' ||
                          rpad ('%prt', 6, ' ')     || ' ' ||
                          rpad ('Opcio guan.', 10, ' ')  || ' ' ||
                          rpad ('%vot.', 6, ' '));
                            

    dbms_output.put_line (rpad ('-', 20, '-') || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 15, '-')     || ' ' ||
                          rpad ('-', 6, '-') || ' ' ||
                          rpad ('-', 6, '-')     || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 6, '-'));

    Fetch cLlistat into vINFTITVOT, vDATINIVOT, vDATFINVOT, vESTVOT, vNUMCTDVOT, vPRCPRT, vCODOPVGUA, vPRCOPVGUA;
    While cLlistat%FOUND loop
      dbms_output.put_line (rpad (substr (vINFTITVOT, 1, 20), 20, ' ') || ' ' ||
                            to_char (vDATINIVOT, 'dd-mm-rrrr')  || ' ' ||
                            to_char (vDATFINVOT, 'dd-mm-rrrr')  || ' ' ||
                            rpad (vESTVOT, 15, ' ')     || ' ' ||
                            lpad (vNUMCTDVOT, 6, ' ') || ' ' ||
                            lpad (vPRCPRT, 6, ' ')     || ' ' ||
                            rpad (vCODOPVGUA, 10, ' ')  || ' ' ||
                            lpad (vPRCOPVGUA, 6, ' '));
      Fetch cLlistat into vINFTITVOT, vDATINIVOT, vDATFINVOT, vESTVOT, vNUMCTDVOT, vPRCPRT, vCODOPVGUA, vPRCOPVGUA;
    end loop;
    Close cLlistat;    
  end if;
                                   

  dbms_output.put_line('10 Votacions amb ms diferencia');  
  CONSULTES_PKG.VOTACIONS_MES_DIFERENCIA (vRsp, cLlistat);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line (rpad ('TTOL', 20, ' ') || ' ' ||
                          rpad ('Inici', 10, ' ')  || ' ' ||
                          rpad ('Fi', 10, ' ')  || ' ' ||
                          rpad ('Op.max', 10, ' ')     || ' ' ||
                          rpad ('%prt.', 6, ' ') || ' ' ||
                          rpad ('Op.min', 10, ' ')     || ' ' ||
                          rpad ('%prt', 6, ' ')  || ' ' ||
                          rpad ('%dif.', 6, ' '));
                            

    dbms_output.put_line (rpad ('-', 20, '-') || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-')     || ' ' ||
                          rpad ('-', 6, '-') || ' ' ||
                          rpad ('-', 10, '-')     || ' ' ||
                          rpad ('-', 6, '-')  || ' ' ||
                          rpad ('-', 6, '-'));

    Fetch cLlistat into vNum, vINFTITVOT, vDATINIVOT, vDATFINVOT, vCOPOPVMAX, vPRCVOTMAX, vCOPOPVMIN , vPRCVOTMIN , vDIFPRCVOT;
    
    While cLlistat%FOUND loop
      dbms_output.put_line (rpad (substr (vINFTITVOT, 1, 20), 20, ' ') || ' ' ||
                            to_char (vDATINIVOT, 'dd-mm-rrrr')  || ' ' ||
                            to_char (vDATFINVOT, 'dd-mm-rrrr')  || ' ' ||
                            rpad (vCOPOPVMAX, 10, ' ')     || ' ' ||
                            lpad (vPRCVOTMAX, 6, ' ') || ' ' ||
                            rpad (vCOPOPVMIN, 10, ' ')     || ' ' ||
                            lpad (vPRCVOTMIN, 6, ' ')  || ' ' ||
                            lpad (vDIFPRCVOT, 6, ' '));
      Fetch cLlistat into vNum, vINFTITVOT, vDATINIVOT, vDATFINVOT, vCOPOPVMAX, vPRCVOTMAX,vCOPOPVMIN , vPRCVOTMIN , vDIFPRCVOT;
    end loop;
    Close cLlistat;    
  end if;
  
  dbms_output.put_line('10 Votacions amb menys diferencia');    
  CONSULTES_PKG.VOTACIONS_MENYS_DIFERENCIA (vRsp, cLlistat);
if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line (rpad ('TTOL', 20, ' ') || ' ' ||
                          rpad ('Inici', 10, ' ')  || ' ' ||
                          rpad ('Fi', 10, ' ')  || ' ' ||
                          rpad ('Op.max', 10, ' ')     || ' ' ||
                          rpad ('%prt.', 6, ' ') || ' ' ||
                          rpad ('Op.min', 10, ' ')     || ' ' ||
                          rpad ('%prt', 6, ' ')  || ' ' ||
                          rpad ('%dif.', 6, ' '));
                            

    dbms_output.put_line (rpad ('-', 20, '-') || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-')     || ' ' ||
                          rpad ('-', 6, '-') || ' ' ||
                          rpad ('-', 10, '-')     || ' ' ||
                          rpad ('-', 6, '-')  || ' ' ||
                          rpad ('-', 6, '-'));

    Fetch cLlistat into vNum, vINFTITVOT, vDATINIVOT, vDATFINVOT, vCOPOPVMAX, vPRCVOTMAX, vCOPOPVMIN , vPRCVOTMIN , vDIFPRCVOT;
    
    While cLlistat%FOUND loop
      dbms_output.put_line (rpad (substr (vINFTITVOT, 1, 20), 20, ' ') || ' ' ||
                            to_char (vDATINIVOT, 'dd-mm-rrrr')  || ' ' ||
                            to_char (vDATFINVOT, 'dd-mm-rrrr')  || ' ' ||
                            rpad (vCOPOPVMAX, 10, ' ')     || ' ' ||
                            lpad (vPRCVOTMAX, 6, ' ') || ' ' ||
                            rpad (vCOPOPVMIN, 10, ' ')     || ' ' ||
                            lpad (vPRCVOTMIN, 6, ' ')  || ' ' ||
                            lpad (vDIFPRCVOT, 6, ' '));
      Fetch cLlistat into vNum, vINFTITVOT, vDATINIVOT, vDATFINVOT, vCOPOPVMAX, vPRCVOTMAX,vCOPOPVMIN , vPRCVOTMIN , vDIFPRCVOT;
    end loop;
    Close cLlistat;    
  end if;

  dbms_output.put_line('Censos d''un ciutad');
  CONSULTES_PKG.CENSOS_CIUTADA ('000011', vRsp, cLlistat);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line (rpad ('CENS', 15, ' '));

    dbms_output.put_line (rpad ('-', 15, '-'));

    Fetch cLlistat into vCodCen;
    
    While cLlistat%FOUND loop
      dbms_output.put_line (rpad (vCodCen, 15, ' '));
      Fetch cLlistat into vCodCen;
    end loop;
    Close cLlistat;    
  end if;

  CONSULTES_PKG.VOTACIONS_CIUTADA ('000011', vRsp, cLlistat);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line (rpad ('TTOL', 20, ' ') || ' ' ||
                          rpad ('Inici', 10, ' ')  || ' ' ||
                          rpad ('Fi', 10, ' ')  || ' ' ||
                          rpad ('Participa', 10, ' '));

    dbms_output.put_line (rpad ('-', 20, '-') || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-')  || ' ' ||
                          rpad ('-', 10, '-'));

    Fetch cLlistat into vINFTITVOT, vDATINIVOT, vDATFINVOT, vVar;
    
    While cLlistat%FOUND loop
      dbms_output.put_line (rpad (substr (vINFTITVOT, 1, 20), 20, ' ') || ' ' ||
                            to_char (vDATINIVOT, 'dd-mm-rrrr')  || ' ' ||
                            to_char (vDATFINVOT, 'dd-mm-rrrr')  || ' ' ||
                            rpad (vVar, 10, ' '));
      Fetch cLlistat into vINFTITVOT, vDATINIVOT, vDATFINVOT, vVar;
    end loop;
    Close cLlistat;    
  end if;
  
end;
/
  
exit
/
