set termout off
set feedback off
set trims on
set serveroutput on
spool .\resultats\geografic.txt

declare
  vRsp    varchar2(4000);
  vVar    varchar2(4000);
begin
  dbms_output.put_line('-- ====================================================================');
  dbms_output.put_line('-- Joc de proves per als procediments del subsistema geogrfic');
  dbms_output.put_line('-- Es realitzen AMB sobre estats, regions i localitats.');
  dbms_output.put_line('--');
  dbms_output.put_line('-- ====================================================================');
  dbms_output.put_line('--');
  dbms_output.put_line('-- --------------------------------------------------------------------');
  dbms_output.put_line('-- ESTATS');
  dbms_output.put_line('-- --------------------------------------------------------------------');
  dbms_output.put_line('--');
  dbms_output.put_line('--'); 

  dbms_output.put_line('Alta correcte');
  geografic_pkg.estat_alta ('PR','PROVA', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Alta error duplicat');
  geografic_pkg.estat_alta ('PR','PROVA', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Modificar correcte');
  geografic_pkg.estat_modificacio ('PR','PROVA2', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    Select nomest
      into vVar
      from estat
      where codest = 'PR';
    
    dbms_output.put_line(vRsp || '- Valor modificar: ' || vVar);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Modificar error no existeix');
  geografic_pkg.estat_modificacio ('PT','PROVA2', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Baixa error no existeix');
  geografic_pkg.estat_baixa ('PT', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Baixa correcte');
  geografic_pkg.estat_baixa ('PR', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line(' ');
  dbms_output.put_line('-- --------------------------------------------------------------------');
  dbms_output.put_line('-- REGIONS');
  dbms_output.put_line('-- --------------------------------------------------------------------');
  dbms_output.put_line(' ');

  dbms_output.put_line('Alta correcte');
  geografic_pkg.regio_alta ('ES', 'PR','PROVA', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Alta error duplicat');
  geografic_pkg.regio_alta ('ES', 'PR', 'PROVA', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Modificar correcte');
  geografic_pkg.regio_modificacio ('ES', 'PR', 'PROVA2', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    Select nomreg
      into vVar
      from regio
      where est_codest = 'ES' and codreg = 'PR';
    
    dbms_output.put_line(vRsp || '- Valor modificar: ' || vVar);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Modificar error no existeix');
  geografic_pkg.regio_modificacio ('ES','PT', 'PROVA2', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Baixa error no existeix');
  geografic_pkg.regio_baixa ('ES', 'PT', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Baixa correcte');
  geografic_pkg.regio_baixa ('ES', 'PR', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;
  

  dbms_output.put_line(' ');
  dbms_output.put_line('-- --------------------------------------------------------------------');
  dbms_output.put_line('-- LOCALITATS');
  dbms_output.put_line('-- --------------------------------------------------------------------');
  dbms_output.put_line(' ');

  dbms_output.put_line('Alta correcte');
  geografic_pkg.localitat_alta ('ES', '01', 'PR','PROVA', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Alta error duplicat');
  geografic_pkg.localitat_alta ('ES', '01', 'PR', 'PROVA', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Modificar correcte');
  geografic_pkg.localitat_modificacio ('ES', '01', 'PR', 'PROVA2', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    Select nomloc
      into vVar
      from localitat
      where est_codest = 'ES' and reg_codreg = '01' and codloc = 'PR';
    
    dbms_output.put_line(vRsp || '- Valor modificar: ' || vVar);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Modificar error no existeix');
  geografic_pkg.localitat_modificacio ('ES', '01', 'PT', 'PROVA2', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Baixa error no existeix');
  geografic_pkg.localitat_baixa ('ES', '01', 'PT', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('--'); 
  dbms_output.put_line('Baixa correcte');
  geografic_pkg.localitat_baixa ('ES', '01', 'PR', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;
  
  commit;
end;
/

spool off

exit
/