set termout off
set feedback off
set trims on
set serveroutput on size unlimited
spool .\resultats\votacio.txt

declare
  vRsp    varchar2(4000);
  vVar    varchar2(4000);
begin
  dbms_output.put_line('-- ====================================================================');
  dbms_output.put_line('-- Joc de proves per als procediments del subsistema de votacions');
  dbms_output.put_line('-- Es realitzen AMB de votacions, opcions votaci, censo votaci...');
  dbms_output.put_line('--');
  dbms_output.put_line('-- ====================================================================');
  dbms_output.put_line('--');

  dbms_output.put_line('Votaci: Alta correcta');
  votacio_pkg.votacio_alta ('001',
                            'VOTACI 1',
                            'VOTACI 1',
                            to_date ('15/12/2011', 'dd/mm/yyyy'),
                            to_date ('22/12/2011', 'dd/mm/yyyy'),
                            to_date ('28/12/2011', 'dd/mm/yyyy'),
                            'NOM PRESIDENT MESA',
                            null,
                            vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Votaci: Alta error codi duplicat');
  votacio_pkg.votacio_alta ('001',
                            'VOTACI 1',
                            'VOTACI 1',
                            to_date ('15/12/2011', 'dd/mm/yyyy'),
                            to_date ('22/12/2011', 'dd/mm/yyyy'),
                            to_date ('28/12/2011', 'dd/mm/yyyy'),
                            'NOM PRESIDENT MESA',
                            null,
                            vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Votaci: Modificaci error no existeix');
  votacio_pkg.votacio_modificacio ('ERROR1',
                                   'VOTACI 1',
                                   'VOTACI 1',
                                   to_date ('15/12/2011', 'dd/mm/yyyy'),
                                   to_date ('22/12/2011', 'dd/mm/yyyy'),
                                   to_date ('28/12/2011', 'dd/mm/yyyy'),
                                   'NOM PRESIDENT MESA',
                                   null,
                                   vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Votaci: Modificaci correcte');
  votacio_pkg.votacio_modificacio ('001',
                                   'VOTACI 1',
                                   'VOTACI 1 CANVIAT',
                                   to_date ('15/12/2011', 'dd/mm/yyyy'),
                                   to_date ('22/12/2011', 'dd/mm/yyyy'),
                                   to_date ('28/12/2011', 'dd/mm/yyyy'),
                                   'NOM PRESIDENT MESA',
                                   null,
                                   vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    Select vot.desvot
      into vVar
      from votacio vot
      where codvot = '001';
      
    dbms_output.put_line(vRsp || ' Valor modificar: ' || vVar);
  end if;
  

  -- OPCIONS
    
  dbms_output.put_line('Opci votaci: Alta correcta');
  votacio_pkg.opcio_alta ('001',
                          'OP1',
                          'OPCI 1',
                          'DESCRIPCI OPCI 1',
                          vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;
 
  dbms_output.put_line('Opci votaci: Alta error duplicat');
  votacio_pkg.opcio_alta ('001',
                          'OP1',
                          'OPCI 1',
                          'DESCRIPCI OPCI 1',
                          vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Opci votaci: Modificaci error no existeix');
  votacio_pkg.opcio_modificacio ('001',
                                 'ERROR1',
                                 'OPCI 1',
                                 'DESCRIPCI OPCI 1',
                                 vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;
  
  dbms_output.put_line('Opci votaci: Modificaci error no existeix');
  votacio_pkg.opcio_modificacio ('001',
                                 'OP1',
                                 'OPCI 1 MODIFICAT',
                                 'DESCRIPCI OPCI 1',
                                 vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    Select opv.INFTITOPV
      into vVar
      from OPCIO_VOTACIO opv
      where opv.VOT_CODVOT = '001' and
            opv.CODOPV = 'OP1';
            
    dbms_output.put_line(vRsp || ' Valor modificat: ' || vVar);
  end if;
  
  
  -- CENSOS
  dbms_output.put_line('Cens votaci: Alta correcte');
  votacio_pkg.cens_votacio_alta ('001', 'ES_09', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Cens votaci: Alta error ja assignat');
  votacio_pkg.cens_votacio_alta ('001', 'ES_09', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Cens votaci: Alta error cens nivell superior ja assignat');
  votacio_pkg.cens_votacio_alta ('001', 'ES_09_430629', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Cens votaci: Alta error cens no existeix');
  votacio_pkg.cens_votacio_alta ('001', 'ERROR1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Cens votaci: Baixa error cens no assignat');
  votacio_pkg.cens_votacio_baixa ('001', 'ES_09_430555', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Cens votaci: Baixa correcte');
  votacio_pkg.cens_votacio_baixa ('001', 'ES_09', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;
  
  dbms_output.put_line('Opci votaci: Baixa error no existeix');
  votacio_pkg.opcio_baixa ('001', 'ERROR1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Opci votaci: Baixa correcte');
  votacio_pkg.opcio_baixa ('001', 'OP1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Votaci: Baixa error no existeix');
  votacio_pkg.votacio_baixa ('ERROR1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Votaci: Baixa correcte');
  votacio_pkg.votacio_baixa ('001', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;
  
  -- Ciutada emet vot
  dbms_output.put_line('Vot ems: Alta error ciutada no existeix');
  votacio_pkg.ciutada_emet_vot ('40346417R', '001', 'OP1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Vot ems: Alta error ciutada no t dret a vot');
  votacio_pkg.ciutada_emet_vot ('017723', '001', 'OP1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Vot ems: Alta error votacio no existeix');
  votacio_pkg.ciutada_emet_vot ('066551', 'ERROR1', 'OP1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Vot ems: Alta error opcio votacio no existeix');
  votacio_pkg.ciutada_emet_vot ('066551', '001', 'ERROR1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  dbms_output.put_line('Vot ems: Alta votacio corrrecte');
  votacio_pkg.ciutada_emet_vot ('066551', '001', 'OP1', vRsp);
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else 
    dbms_output.put_line(vRsp);
  end if;

  -- Tancar votaci

  votacio_pkg.votacio_alta ('001',
                            'VOTACI 1',
                            'VOTACI 1',
                            to_date ('15/12/2011', 'dd/mm/yyyy'),
                            to_date ('22/12/2011', 'dd/mm/yyyy'),
                            to_date ('28/12/2011', 'dd/mm/yyyy'),
                            'NOM PRESIDENT MESA',
                            null,
                            vRsp); 
                            
  votacio_pkg.cens_votacio_alta ('001', 'ES_09', vRsp);
  votacio_pkg.cens_votacio_alta ('001', 'ES_09', vRsp);
  votacio_pkg.ciutada_emet_vot  ('066551', '001', 'OP1', vRsp);
  
  dbms_output.put_line('Votaci: Tancar votacio error votacio no existeix');
  votacio_pkg.votacio_tancar ('ERROR1', vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp || ' Valor modificar: ' || vVar);
  end if;

  dbms_output.put_line('Votaci: Tancar votacio error data fi no arribada');
  votacio_pkg.votacio_tancar ('001', vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp || ' Valor modificar: ' || vVar);
  end if;  

  Update votacio
    set datpubvot = '15/11/2011',
        datinivot = '22/11/2011',
        datfinvot = '08/12/2011',
        estvot     = 'INI'
    where codvot = '001';

  dbms_output.put_line('Votaci: Tancar votacio correcte');
  votacio_pkg.votacio_tancar ('001', vRsp); 
  if vRsp != 'OK' then
    dbms_output.put_line('Error---> ' || vRsp);
  else
    dbms_output.put_line(vRsp);
  end if;

  delete from esd_any;
  delete from esd_cens_any;
  delete from esd_estat_any;
  delete from esd_votacio;
  delete from vot_emes where vot_codvot = '001';
  delete from opcio_votacio where vot_codvot = '001';
  delete from cens_votacio where vot_codvot = '001';
  delete from votacio where codvot = '001';
  
  commit;
end;
/

spool off

exit
/
